/*

   BLIS    
   An object-based framework for developing high-performance BLAS-like
   libraries.

   Copyright (C) 2014, The University of Texas at Austin

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:
    - Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    - Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    - Neither the name of The University of Texas at Austin nor the names
      of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef BLIS_PACKM_IND_PRE_MACRO_DEFS_H
#define BLIS_PACKM_IND_PRE_MACRO_DEFS_H


// packm_2xk_3mis kernels

#define BLIS_CPACKM_2XK_3MIS_KERNEL_REF  bli_cpackm_2xk_3mis_ref
#define BLIS_ZPACKM_2XK_3MIS_KERNEL_REF  bli_zpackm_2xk_3mis_ref

// packm_4xk_3mis kernels

#define BLIS_CPACKM_4XK_3MIS_KERNEL_REF  bli_cpackm_4xk_3mis_ref
#define BLIS_ZPACKM_4XK_3MIS_KERNEL_REF  bli_zpackm_4xk_3mis_ref

// packm_6xk_3mis kernels

#define BLIS_CPACKM_6XK_3MIS_KERNEL_REF  bli_cpackm_6xk_3mis_ref
#define BLIS_ZPACKM_6XK_3MIS_KERNEL_REF  bli_zpackm_6xk_3mis_ref

// packm_8xk_3mis kernels

#define BLIS_CPACKM_8XK_3MIS_KERNEL_REF  bli_cpackm_8xk_3mis_ref
#define BLIS_ZPACKM_8XK_3MIS_KERNEL_REF  bli_zpackm_8xk_3mis_ref

// packm_10xk_3mis kernels

#define BLIS_CPACKM_10XK_3MIS_KERNEL_REF bli_cpackm_10xk_3mis_ref
#define BLIS_ZPACKM_10XK_3MIS_KERNEL_REF bli_zpackm_10xk_3mis_ref

// packm_12xk_3mis kernels

#define BLIS_CPACKM_12XK_3MIS_KERNEL_REF bli_cpackm_12xk_3mis_ref
#define BLIS_ZPACKM_12XK_3MIS_KERNEL_REF bli_zpackm_12xk_3mis_ref

// packm_14xk_3mis kernels

#define BLIS_CPACKM_14XK_3MIS_KERNEL_REF bli_cpackm_14xk_3mis_ref
#define BLIS_ZPACKM_14XK_3MIS_KERNEL_REF bli_zpackm_14xk_3mis_ref

// packm_16xk_3mis kernels

#define BLIS_CPACKM_16XK_3MIS_KERNEL_REF bli_cpackm_16xk_3mis_ref
#define BLIS_ZPACKM_16XK_3MIS_KERNEL_REF bli_zpackm_16xk_3mis_ref

// packm_30xk_3mis kernels

#define BLIS_CPACKM_30XK_3MIS_KERNEL_REF bli_cpackm_30xk_3mis_ref
#define BLIS_ZPACKM_30XK_3MIS_KERNEL_REF bli_zpackm_30xk_3mis_ref



// packm_2xk_4mi kernels

#define BLIS_CPACKM_2XK_4MI_KERNEL_REF   bli_cpackm_2xk_4mi_ref
#define BLIS_ZPACKM_2XK_4MI_KERNEL_REF   bli_zpackm_2xk_4mi_ref

// packm_4xk_4mi kernels

#define BLIS_CPACKM_4XK_4MI_KERNEL_REF   bli_cpackm_4xk_4mi_ref
#define BLIS_ZPACKM_4XK_4MI_KERNEL_REF   bli_zpackm_4xk_4mi_ref

// packm_6xk_4mi kernels

#define BLIS_CPACKM_6XK_4MI_KERNEL_REF   bli_cpackm_6xk_4mi_ref
#define BLIS_ZPACKM_6XK_4MI_KERNEL_REF   bli_zpackm_6xk_4mi_ref

// packm_8xk_4mi kernels

#define BLIS_CPACKM_8XK_4MI_KERNEL_REF   bli_cpackm_8xk_4mi_ref
#define BLIS_ZPACKM_8XK_4MI_KERNEL_REF   bli_zpackm_8xk_4mi_ref

// packm_10xk_4mi kernels

#define BLIS_CPACKM_10XK_4MI_KERNEL_REF  bli_cpackm_10xk_4mi_ref
#define BLIS_ZPACKM_10XK_4MI_KERNEL_REF  bli_zpackm_10xk_4mi_ref

// packm_12xk_4mi kernels

#define BLIS_CPACKM_12XK_4MI_KERNEL_REF  bli_cpackm_12xk_4mi_ref
#define BLIS_ZPACKM_12XK_4MI_KERNEL_REF  bli_zpackm_12xk_4mi_ref

// packm_14xk_4mi kernels

#define BLIS_CPACKM_14XK_4MI_KERNEL_REF  bli_cpackm_14xk_4mi_ref
#define BLIS_ZPACKM_14XK_4MI_KERNEL_REF  bli_zpackm_14xk_4mi_ref

// packm_16xk_4mi kernels

#define BLIS_CPACKM_16XK_4MI_KERNEL_REF  bli_cpackm_16xk_4mi_ref
#define BLIS_ZPACKM_16XK_4MI_KERNEL_REF  bli_zpackm_16xk_4mi_ref

// packm_30xk_4mi kernels

#define BLIS_CPACKM_30XK_4MI_KERNEL_REF  bli_cpackm_30xk_4mi_ref
#define BLIS_ZPACKM_30XK_4MI_KERNEL_REF  bli_zpackm_30xk_4mi_ref



// packm_2xk_rih kernels

#define BLIS_CPACKM_2XK_RIH_KERNEL_REF   bli_cpackm_2xk_rih_ref
#define BLIS_ZPACKM_2XK_RIH_KERNEL_REF   bli_zpackm_2xk_rih_ref

// packm_4xk_rih kernels

#define BLIS_CPACKM_4XK_RIH_KERNEL_REF   bli_cpackm_4xk_rih_ref
#define BLIS_ZPACKM_4XK_RIH_KERNEL_REF   bli_zpackm_4xk_rih_ref

// packm_6xk_rih kernels

#define BLIS_CPACKM_6XK_RIH_KERNEL_REF   bli_cpackm_6xk_rih_ref
#define BLIS_ZPACKM_6XK_RIH_KERNEL_REF   bli_zpackm_6xk_rih_ref

// packm_8xk_rih kernels

#define BLIS_CPACKM_8XK_RIH_KERNEL_REF   bli_cpackm_8xk_rih_ref
#define BLIS_ZPACKM_8XK_RIH_KERNEL_REF   bli_zpackm_8xk_rih_ref

// packm_10xk_rih kernels

#define BLIS_CPACKM_10XK_RIH_KERNEL_REF  bli_cpackm_10xk_rih_ref
#define BLIS_ZPACKM_10XK_RIH_KERNEL_REF  bli_zpackm_10xk_rih_ref

// packm_12xk_rih kernels

#define BLIS_CPACKM_12XK_RIH_KERNEL_REF  bli_cpackm_12xk_rih_ref
#define BLIS_ZPACKM_12XK_RIH_KERNEL_REF  bli_zpackm_12xk_rih_ref

// packm_14xk_rih kernels

#define BLIS_CPACKM_14XK_RIH_KERNEL_REF  bli_cpackm_14xk_rih_ref
#define BLIS_ZPACKM_14XK_RIH_KERNEL_REF  bli_zpackm_14xk_rih_ref

// packm_16xk_rih kernels

#define BLIS_CPACKM_16XK_RIH_KERNEL_REF  bli_cpackm_16xk_rih_ref
#define BLIS_ZPACKM_16XK_RIH_KERNEL_REF  bli_zpackm_16xk_rih_ref

// packm_30xk_rih kernels

#define BLIS_CPACKM_30XK_RIH_KERNEL_REF  bli_cpackm_30xk_rih_ref
#define BLIS_ZPACKM_30XK_RIH_KERNEL_REF  bli_zpackm_30xk_rih_ref



#endif 

